#include <stdio.h>
#include <stdlib.h>

static unsigned
pred (unsigned k, unsigned n)
{
  return k == 1 ? n : k - 1;
}

static unsigned
nasl (unsigned k, unsigned n)
{
  return k == n ? 1 : k + 1;
}

static void
grand (FILE *f, int n)
{
  int a, b, i;

  fprintf (f, "%d\n", n);
  a = (rand () % n) + 1;
  b = nasl (nasl (a, n), n);
  for (i = 0; i < n - 3; i++)
    {
      fprintf (f, "%d %d\n", a, b);
      if (rand () % 2)
	b = nasl (b, n);
      else
	a = pred (a, n);
    }
}

static void
gstar (FILE *f, int n, int rc)
{
  int i, c, a;

  fprintf (f, "%d\n", n);
  if (rc)
    c = (rand () % n) + 1;
  else
    c = 1;

  a = nasl (nasl (c, n), n);
  for (i = 0; i < n - 3; i++)
    {
      fprintf (f, "%d %d\n", a, c);
      a = nasl (a, n);
    }
}

static void
gdstar (FILE *f, int n)
{
  int i, c, a, fp = (n - 3) / 2;

  fprintf (f, "%d\n", n);
  c = (rand () % n) + 1;
  a = nasl (nasl (c, n), n);

  for (i = 0; i < fp; i++)
    {
      fprintf (f, "%d %d\n", a, c);
      a = nasl (a, n);
    }
  c = pred (a, n);
  a = nasl (a, n);
  for (; i < n-3; i++)
    {
      fprintf (f, "%d %d\n", a, c);
      a = nasl (a, n);
    }
}

int main(void)
{
  FILE *f;

  srand (0);

  /* Nahodna strategie - 3 body.  */
  f = fopen ("01.in", "w");
  fprintf (f, "0 ");
  grand (f, 100);
  fclose (f);

  f = fopen ("02.in", "w");
  fprintf (f, "0 ");
  grand (f, 100000);
  fclose (f);

  f = fopen ("03.in", "w");
  fprintf (f, "0 ");
  gdstar (f, 10000);
  fclose (f);

  /* Optimalni strategie.  */

  /* 3 body za n <= 10.  */
  f = fopen ("04.in", "w");
  fprintf (f, "1 6\n");
  fprintf (f, "1 3 3 6 6 4\n");
  fclose (f);

  f = fopen ("05.in", "w");
  fprintf (f, "1 3\n");
  fclose (f);

  f = fopen ("06.in", "w");
  fprintf (f, "1 ");
  grand (f, 10);
  fclose (f);

  /* 4 body za sousedc s jednm vrcholem.  */
  f = fopen ("07.in", "w");
  fprintf (f, "1 ");
  gstar (f, 10000, 0);
  fclose (f);

  f = fopen ("08.in", "w");
  fprintf (f, "1 ");
  gstar (f, 50000, 1);
  fclose (f);

  f = fopen ("09.in", "w");
  fprintf (f, "1 ");
  gstar (f, 100000, 0);
  fclose (f);

  f = fopen ("10.in", "w");
  fprintf (f, "1 ");
  gstar (f, 100000, 1);
  fclose (f);

  /* 5 bod za zbytek.  */
  f = fopen ("11.in", "w");
  fprintf (f, "1 ");
  grand (f, 50000);
  fclose (f);

  f = fopen ("12.in", "w");
  fprintf (f, "1 ");
  grand (f, 100000);
  fclose (f);

  f = fopen ("13.in", "w");
  fprintf (f, "1 ");
  gdstar (f, 50000);
  fclose (f);

  f = fopen ("14.in", "w");
  fprintf (f, "1 ");
  gdstar (f, 100000);
  fclose (f);

  f = fopen ("15.in", "w");
  fprintf (f, "1 ");
  grand (f, 100000);
  fclose (f);

  return 0;
}
