#include <vector>
#include "volby.h"
#define DEGEN 6
#define KAND 5
using namespace std;

/* Poet pn.  */
static int n;

struct spion
{
  vector<int> zna;		/* Seznam znmch pin.  */
  vector<int> zamnou;	/* Seznam tch, co jsou za mnou.  */
  int kand;		/* Aktuln volen kandidt.  */
  int pred_pro_kand[KAND];	/* Poet pin pede mnou, volcch danho kandidta.  */

  spion(void) : zna(), zamnou(), kand(0)
    {
      int i;
      for (i = 0; i < KAND; i++)
	pred_pro_kand[i] = 0;
    }
};

/* Seznam pin.  */
static vector<spion> sezsp;

/* Poet bod pro danho kandidta.  */
static int bodu[KAND];

/* Nalezne poad takov, aby kad znal nanejv DEGEN pn
   za nm.  */
static void
urci_poradi (void)
{
  /* Zda u byl pin odebrn.  */
  bool odebran[n];
  /* Poet zbvajcch znmch.  */
  int znamych[n];
  /* Seznam pin s nanev DEGEN znmmi.  */
  vector<int> malo;
  int i;

  for (i = 0; i < n; i++)
    {
      odebran[i] = false;
      znamych[i] = sezsp[i].zna.size();
      if (znamych[i] <= DEGEN)
	malo.push_back (i);
    }

  while (!malo.empty ())
    {
      int aktualni = malo.back ();
      malo.pop_back ();

      odebran[aktualni] = true;
      vector<int>::iterator s = sezsp[aktualni].zna.begin ();
      vector<int>::iterator se = sezsp[aktualni].zna.end ();
      for (; s < se; ++s)
	if (!odebran[*s])
	  {
	    sezsp[aktualni].zamnou.push_back (*s);
	    znamych[*s]--;
	    if (znamych[*s] == DEGEN)
	      malo.push_back (*s);
	  }
    }
}

static void
inicializuj_pocty (void)
{
  int s;
  vector <int>::iterator sous;

  for (s = 0; s < n; s++)
    for (sous = sezsp[s].zamnou.begin(); sous != sezsp[s].zamnou.end(); ++sous)
      sezsp[*sous].pred_pro_kand[sezsp[s].kand]++;

  for (s = 0; s < n; s++)
    bodu[sezsp[s].kand] += sezsp[s].pred_pro_kand[sezsp[s].kand];
}

void
spioni (int inpn, int m, int znaji_se[][2], int voli[])
{
  int i;

  n = inpn;
  sezsp.resize (n + 1);
  for (i = 0; i < n; i++)
    sezsp[i].kand = voli[i];
  for (i = 0; i < m; i++)
    {
      int s1 = znaji_se[i][0];
      int s2 = znaji_se[i][1];
      sezsp[s1].zna.push_back (s2);
      sezsp[s2].zna.push_back (s1);
    }
  urci_poradi ();
  inicializuj_pocty();
}

void
zmen_nazor (int spion, int voli)
{
  int puvodni = sezsp[spion].kand;
  int pro_puv = 0, pro_nov = 0;
  vector<int>::iterator sous;

  if (puvodni == voli)
    return;
  sezsp[spion].kand = voli;

  for (sous = sezsp[spion].zamnou.begin(); sous != sezsp[spion].zamnou.end(); ++sous)
    {
      int skand = sezsp[*sous].kand;

      if (skand == puvodni)
	pro_puv++;
      else if (skand == voli)
	pro_nov++;

      sezsp[*sous].pred_pro_kand[puvodni]--;
      sezsp[*sous].pred_pro_kand[voli]++;
    }

  bodu[puvodni] -= sezsp[spion].pred_pro_kand[puvodni] + pro_puv;
  bodu[voli] += sezsp[spion].pred_pro_kand[voli] + pro_nov;
}

void pocet_bodu (int pocet[KAND])
{
  int i;
  for (i = 0; i < KAND; i++)
    pocet[i] = bodu[i];
}

